"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var _ = require("underscore");
var classNames = require("classnames");
var icon_1 = require("./../display/icon");
var Button = (function (_super) {
    tslib_1.__extends(Button, _super);
    function Button() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Button.prototype.handleClick = function (e) {
        if (this.props.onClick && !this.props.pending) {
            this.props.onClick(e);
        }
    };
    Button.prototype.render = function () {
        var _this = this;
        var attrs = _.omit(this.props, "onClick", "leftIcon", "rightIcon", "className", "rounded", "context", "pending", "disabled");
        var classes = classNames("btn", this.props.className, {
            "rounded": this.props.rounded,
            "icon-button-left": this.props.leftIcon !== undefined,
            "icon-button-right": this.props.rightIcon !== undefined,
            "pending": this.props.pending
        });
        return (React.createElement("button", tslib_1.__assign({ disabled: this.props.pending || this.props.disabled, type: this.props.type || 'button', onClick: function (e) { return _this.handleClick(e); } }, attrs, { className: classes }),
            this.props.leftIcon && React.createElement(icon_1.Icon, { className: "left-icon", icon: this.props.leftIcon }),
            this.props.children,
            this.props.rightIcon && React.createElement(icon_1.Icon, { className: "right-icon", icon: this.props.rightIcon })));
    };
    return Button;
}(React.Component));
exports.Button = Button;
